#!/usr/bin/env python3
# -*- encoding: utf-8 -*-

import datetime
import json
from pathlib import Path

import requests

from flask import Flask, make_response, render_template, request, send_file

shared_solution_key = Path(__file__).parent.joinpath(
    'shared_solution_key.txt').read_text(encoding='utf-8').strip()
app = Flask(__name__, instance_relative_config=True)


@app.route('/', methods=['HEAD', 'OPTIONS', 'GET'])
def index():
    return render_template('index.html', datetime=datetime)


@app.route('/favicon.ico', methods=['HEAD', 'OPTIONS', 'GET'])
def favicon():
    return send_file(Path('favicon.ico'))


@app.route('/convert.html', methods=['HEAD', 'OPTIONS', 'GET'])
def convert():
    key = request.args.get('key', '').strip()
    if shared_solution_key != key:
        raise ValueError('Wrong access key')
    resp = requests.get('https://patas.site/api/programacao')
    resp.raise_for_status()
    dias = resp.json()
    del resp
    return render_template('table.html', dias=dias)
